# member-administration-server

Mitgliederverwaltung für Feuerwehren und Vereine (Backend).

## Einleitung

Dieses Projekt, `member-administration-server`, ist das Backend zur Verwaltung von Mitgliederdaten. Die zugehörige Webapp ist im Repository [member-administration-ui](https://forgejo.jk-effects.cloud/Ehrenamt/member-administration-ui) zu finden.

Eine Demo zusammen mit der `member-administration-ui` finden Sie unter [ff-admin-demo.jk-effects.cloud](ff-admin-demo.jk-effects.cloud).

## Installation

### Docker Compose Setup

Um den Container hochzufahren, erstellen Sie eine `docker-compose.yml` Datei mit folgendem Inhalt:

```yaml
version: "3"

services:
  ff-member-administration-server:
    image: docker.registry.jk-effects.cloud/ehrenamt/member-administration/server:latest
    container_name: ff_member_administration_server
    restart: unless-stopped
    environment:
      - DB_TYPE = mysql
      - DB_HOST=ffm-db
      - DB_NAME=administration
      - DB_USERNAME=administration_backend
      - DB_PASSWORD=<dbuserpasswd>
      - JWT_SECRET=<tobemodified>
      - JWT_EXPIRATION=<number[m|d] - bsp.:15m>
      - REFRESH_EXPIRATION=<number[m|d] - bsp.:1d>
      - MAIL_USERNAME=<mailadress|username>
      - MAIL_PASSWORD=<password>
      - MAIL_HOST=<url>
      - MAIL_PORT=<port>
      - MAIL_SECURE=<boolean>
      - CLUB_NAME=<tobemodified>
    volumes:
      - <volume|local path>:/app/export
    networks:
      - ff_internal
    depends_on:
      - ff-db

  ff-db:
    image: mariadb:11.2
    container_name: ff_db
    restart: unless-stopped
    environment:
      - MYSQL_DATABASE=ffadmin
      - MYSQL_USER=administration_backend
      - MYSQL_PASSWORD=<dbuserpasswd>
      - MYSQL_ROOT_PASSWORD=<dbrootpasswd>
    volumes:
      - <volume|local path>:/var/lib/mysql
    networks:
      - ff_internal

networks:
  ff_internal:
```

Führen Sie dann den folgenden Befehl im Verzeichnis der compose-Datei aus, um den Container zu starten:

```sh
docker-compose up -d
```

### Manuelle Installation

Klonen Sie dieses Repository und installieren Sie die Abhängigkeiten:

```sh
git clone https://forgejo.jk-effects.cloud/Ehrenamt/member-administration-server.git
cd member-administration-server
npm install
npm run build
npm run start
```

## Fragen und Wünsche

Bei Fragen, Anregungen oder Wünschen können Sie sich gerne melden.\
Wir freuen uns über Ihr Feedback und helfen Ihnen gerne weiter.\
Schreiben Sie dafür eine Mail an julian.krauser@jk-effects.com.
